<?php

namespace THM\DownloadExplorer\Controller;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2014-2019
 *           Jan Haffner <info@jan-haffner.de>
 *           Rafael Kähm <Rafael@Kaehms.de>
 *           Samuel Mehrbrodt <samuel.mehrbrodt@mni.thm.de>
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use \TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * StandardController.
 */
class StandardController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{

    /**
     * @var \THM\DownloadExplorer\Utility\Files
     */
    protected $fileUtility;

    /**
     * Initializes the controller before invoking an action method.
     *
     * Inializes Files Utility, Sets Settings for Files Utility.
     */
    public function initializeAction()
    {
        $this->fileUtility = GeneralUtility::makeInstance('THM\\DownloadExplorer\\Utility\\Files');
        if($this->settings['hideRootFolder'] == 'typoscript') {
            $this->settings['hideRootFolder'] = $this->settings['hideRootFolderDefault'];
        }
        $this->fileUtility->setSettings($this->settings);
    }

    /**
     * Lists folder tree in frontend.
     */
    public function listAction()
    {
        $subFolderAndFiles = array();
        $this->fileUtility->readDirectoryRecursively($this->settings['rootFolder'], $subFolderAndFiles, true, $this->settings['foldersDepth']);
        $this->view->assign('subfoldersAndFiles', $subFolderAndFiles);
    }
}
